      PARAMETER (LX=144,MX=73)
      REAL G(LX,MX),GG(LX+1,MX)

C ========================================

      CALL RDDAT (LX,MX,G)
      CALL GRID  (LX,MX,G,GG)
      CALL FRAME
      CALL AXIS
      CALL UDICLV
      CALL UDPSET ('ICYCLE',5)
      CALL UDGCLA (920.,1080.,4.)
      CALL UDCNTR (GG,LX+1,LX+1,MX)
      CALL GRCLS
      STOP
      END

C ########################################

      SUBROUTINE RDDAT (LX,MX,G)
      REAL G(LX,MX),GG(144,73)
      CHARACTER INFL*80
      WRITE(6,*) 'Time step # ?'
      READ (5,*) I
C      WRITE(6,*) 'Input file ?'
C      READ (5,'(A80)') INFL
      INFL = 'P0.dat'
      OPEN (10,FILE=INFL,
     +      STATUS='OLD',FORM='UNFORMATTED',
     +      ACCESS='DIRECT',RECL=4*(LX*MX))
      READ (10,REC=1) GG
      CLOSE(10)
      DO 11 M=1,MX
      DO 12 L=1,LX
      MM = MX+1-M
        G(L,M) = GG(L,MM)
   12 CONTINUE
   11 CONTINUE
      IF (I.GE.1) THEN
C      WRITE(6,*) 'Input file ?'
C      READ (5,'(A80)') INFL
      INFL = 'P1.dat'
      OPEN (10,FILE=INFL,
     +      STATUS='OLD',FORM='UNFORMATTED',
     +      ACCESS='DIRECT',RECL=4*(LX*MX))
      READ (10,REC=I) GG
      CLOSE(10)
      DO 21 M=1,MX
      DO 22 L=1,LX
        G(L,M) = 1.0E-2*GG(L,M) + G(L,M)
   22 CONTINUE
   21 CONTINUE
      ENDIF
      RETURN
      END

C ========================================

      SUBROUTINE GRID (LX,MX,G,GG)
      REAL G(LX,MX),GG(LX+1,MX)
      DO 11 M=1,MX
      DO 12 L=1,LX+1
      LL = MOD(LX+L-1,LX)+1
        GG(L,M) = G(LL,M)
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

C ########################################

      SUBROUTINE FRAME
      WRITE(*,*) 'WORKSTATION ID ?'
      CALL SGPWSN
      READ(*,*) IWS
      CALL GROPN (IWS)
      CALL GRFRM
      RETURN
      END

C ========================================

      SUBROUTINE AXIS
      CHARACTER CSGI*1
      CALL GRSWND (0.,360.,-90.,90.)
      CALL GRSVPT (0.1,0.9,0.2,0.8)
      CALL GRSTRN (1)
      CALL GRSTRF
      CALL USPSET ('DXT',30.)
      CALL USPSET ('DXL',60.)
      CALL USPSET ('DYT',10.)
      CALL USPSET ('DYL',30.)
      CALL USCSET ('CBLKT',' ')
      CALL USSTTL (' ','(|'//CSGI(4)//'"E)',' ' ,'(|'//CSGI(4)//'"N)')
      CALL USDAXS
      CALL SGLNZU (0.,0.,360.,0.,3)
      CALL SGQWND (UX1,UX2,UY1,UY2)
      CALL SGLSET ('LCLIP',.TRUE.)
      CALL UMPSET ('LGRIDMJ' ,.FALSE.)
      CALL UMPSET ('INDEXOUT',1)
      CALL UMPMAP ('coast_world')
      CALL UMPSET ('INDEXOUT',1)
      CALL UMPMAP ('border_world')
      CALL GRSWND (UX1-360.,UX2-360.,UY1,UY2)
      CALL GRSTRN (1)
      CALL GRSTRF
      CALL UMPSET ('INDEXOUT',1)
      CALL UMPMAP ('coast_world')
      CALL UMPSET ('INDEXOUT',1)
      CALL UMPMAP ('border_world')
      CALL GRSWND (UX1+360.,UX2+360.,UY1,UY2)
      CALL GRSTRN (1)
      CALL GRSTRF
      CALL UMPSET ('INDEXOUT',1)
      CALL UMPMAP ('coast_world')
      CALL UMPSET ('INDEXOUT',1)
      CALL UMPMAP ('border_world')
      CALL GRSWND (UX1,UX2,UY1,UY2)
      CALL GRSTRN (1)
      CALL GRSTRF
      RETURN
      END
